// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	10先スコア
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

class YmsbFT10 extends YmsbAnime {
	FT10_WIN_1P	= 1;
	FT10_WIN_2P	= 2;
	FT10_DRAW	= 3;

	constructor(moveBox, ft10Opacity) {
		super();
		this.arrCurrFT10Score	= new Array(19);
		this.arrNewFT10Score	= new Array(19);
		this.back				= new YmsbAnime(ft10Opacity, SbCSS.BOX_FT10_BACK, "",
									YMSB_VIRT, moveBox, "", "",
									ANI_DELY_ON_BOX_BOTTOM, ANI_DELY_ON_TXT_BOTTOM);
		this.name				= new Array(2);
		this.name[0]			= new YmsbAnime(1.0, "", SbCSS.TXT_FT10_NAME_1P, "", "",
									YMSB_VIRT, "0px", ANI_DELY_ON_BOX_BOTTOM, ANI_DELY_ON_TXT_BOTTOM);
		this.name[1]			= new YmsbAnime(1.0, "", SbCSS.TXT_FT10_NAME_2P, "", "",
									YMSB_VIRT, "0px", ANI_DELY_ON_BOX_BOTTOM, ANI_DELY_ON_TXT_BOTTOM);
	}

	// 表示
	animeOn() {
		this.back.animeOn("");

		let arrNewFT10Txt = new Array(2);
		for (let i = 0; i < 2; i++) {
			this.name[i].animeOn(cTeamName.arrTeam[i].currData);
		}
		for (let j = 0; j < 19; j++) {
			switch(this.arrNewFT10Score[j]) {
				case this.FT10_WIN_1P:
					arrNewFT10Txt[0] = SB_TXT_FT10_W;
					arrNewFT10Txt[1] = SB_TXT_FT10_L;
					break;
				case this.FT10_WIN_2P:
					arrNewFT10Txt[0] = SB_TXT_FT10_L;
					arrNewFT10Txt[1] = SB_TXT_FT10_W;
					break;
				case this.FT10_DRAW:
					arrNewFT10Txt[0] = SB_TXT_FT10_D;
					arrNewFT10Txt[1] = SB_TXT_FT10_D;
					break;
				default:
					arrNewFT10Txt[0] = "";
					arrNewFT10Txt[1] = "";
					break;
			}	
			for (let i = 0; i < 2; i++) {
				gsap.to (arrTxtFT10ScoreCSS[i][j], 
					{duration:ANI_DUR_BASE, opacity:1.0, ease:ANI_EASE_IN, delay:ANI_DELY_ON_TXT_BOTTOM,
					onStart:YmsbAnime.callBackTextUpdate(arrTxtFT10ScoreCSS[i][j], arrNewFT10Txt[i])});
			}
			this.arrCurrFT10Score[j] = this.arrNewFT10Score[j];
		}
	}

	// 非表示
	animeOff() {
		this.back.animeOff();
		for (let i = 0; i < 2; i++) {
			this.name[i].animeOff();
			for (let j = 0; j < 19; j++) {
				gsap.to (arrTxtFT10ScoreCSS[i][j], 
					{duration:ANI_DUR_BASE, opacity:0.0, ease:ANI_EASE_OUT, delay:ANI_DELY_OFF_TXT});
			}
		}
	}

	// 更新
	animeUpdate() {
		let arrNewFT10Txt = new Array(2);
		for (let i = 0; i < 2; i++) {
			if (this.name[i].currData != cTeamName.arrTeam[i].currData) {
				this.name[i].animeUpdate(cTeamName.arrTeam[i].currData);
			}
		}
		for (let j = 0; j < 19; j++) {
			if (this.arrCurrFT10Score[j] != this.arrNewFT10Score[j]) {
				switch(this.arrNewFT10Score[j]) {
					case this.FT10_WIN_1P:
						arrNewFT10Txt[0] = SB_TXT_FT10_W;
						arrNewFT10Txt[1] = SB_TXT_FT10_L;
						break;
					case this.FT10_WIN_2P:
						arrNewFT10Txt[0] = SB_TXT_FT10_L;
						arrNewFT10Txt[1] = SB_TXT_FT10_W;
						break;
					case this.FT10_DRAW:
						arrNewFT10Txt[0] = SB_TXT_FT10_D;
						arrNewFT10Txt[1] = SB_TXT_FT10_D;
						break;
					default:
						arrNewFT10Txt[0] = "";
						arrNewFT10Txt[1] = "";
						break;
				}	
				for (let i = 0; i < 2; i++) {
					gsap.timeline()
						.to(arrTxtFT10ScoreCSS[i][j], {duration:ANI_DUR_BASE, opacity:0.0, ease:ANI_EASE_IN, delay:ANI_DELY_UPDATE, 
							onComplete:YmsbAnime.callBackTextUpdate(arrTxtFT10ScoreCSS[i][j], arrNewFT10Txt[i])})
						.to(arrTxtFT10ScoreCSS[i][j], {duration:ANI_DUR_BASE, opacity:1.0, ease:ANI_EASE_OUT});
				}
				this.arrCurrFT10Score[j] = this.arrNewFT10Score[j];
			}
		}
	}

	// ■■ 10先スコア計算 ■■
	getScore() {
		let arrNewScore = new Array(2);
		arrNewScore[0] = 0;
		arrNewScore[1] = 0;
		for (let i = 0; i < 19; i++) {
			let newScore1p = jsonData[arrPrmFT10ScoreJSON[0][i]];
			let newScore2p = jsonData[arrPrmFT10ScoreJSON[1][i]];
			if      (YMSB_OFF != newScore1p && YMSB_OFF == newScore2p) {
				this.arrNewFT10Score[i] = this.FT10_WIN_1P;
				arrNewScore[0] ++;
			}
			else if (YMSB_OFF == newScore1p && YMSB_OFF != newScore2p) {
				this.arrNewFT10Score[i] = this.FT10_WIN_2P;
				arrNewScore[1] ++;
			}
			else if (YMSB_OFF != newScore1p && YMSB_OFF != newScore2p) {
				this.arrNewFT10Score[i] = this.FT10_DRAW;
			}
			else {
				this.arrNewFT10Score[i] = YMSB_OFF;
			}
		}
		return arrNewScore;
	}
}
