// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	画像アニメーション
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
const YMSB_URL_IMAGE_COMMON			= "imgs/" + YMSB_COMM;
const YMSB_URL_USER					= YMSB_URL_IMAGE_COMMON + "user/";
const YMSB_URL_LOGO					= YMSB_URL_IMAGE_COMMON + "logo/";
const YMSB_IMAGE_EXT				= ".png";

class YmsbImage {

	constructor(opacity, cssBox, vorhBox, moveBox, delayBox) {
		this.currData	= "";
		this.moveTo		= ANI_MOVE_DEFAULT;
		this.opacity	= opacity;
		this.cssBox		= cssBox;
		this.vorhBox	= vorhBox;
		this.boxFrom	= moveBox;
		this.delayBox	= delayBox;
		this.tlChange	= null;
	}

	// 表示
	animeOn(newImage, cssProp, fChange) {
		let pBoxSet;
		let pBoxTo;
		if (YMSB_VIRT == this.vorhBox) {
			pBoxSet	= {y:this.boxFrom, opacity:1.0};
			pBoxTo  = {y:this.moveTo, overwrite:"auto",
				duration:ANI_DUR_BASE, ease:ANI_EASE_OUT, delay:this.delayBox,
				onStart:this.callBackImageUpdate(this.cssBox, newImage, cssProp)};
		}
		else {
			pBoxSet	= {x:this.boxFrom, opacity:1.0};
			pBoxTo  = {x:this.moveTo, overwrite:"auto",
				duration:ANI_DUR_BASE, ease:ANI_EASE_OUT, delay:this.delayBox,
				onStart:this.callBackImageUpdate(this.cssBox, newImage, cssProp)};
		}
		gsap.timeline()
			.set(this.cssBox, pBoxSet)
			.to (this.cssBox, pBoxTo);
		if (fChange) {
			this.tlChange = gsap.timeline ({repeat:-1})
				.to (this.cssBox, {duration:1.5, opacity:0.0, overwrite:"auto"} ,"+=7.5")
				.to (this.cssBox, {duration:1.5, opacity:1.0, overwrite:"auto"} ,"+=7.5");
			}
	}

	// 非表示
	animeOff(fChange) {
		let pBoxTo;
		if (YMSB_VIRT == this.vorhBox) {
			pBoxTo   = {y:this.boxFrom, repeat:0, 
				duration:ANI_DUR_BASE, ease:ANI_EASE_IN, delay:ANI_DELY_OFF_BOX};
		}
		else {
			pBoxTo   = {x:this.boxFrom, repeat:0,
				duration:ANI_DUR_BASE, ease:ANI_EASE_IN, delay:ANI_DELY_OFF_BOX};
		}
		gsap.to (this.cssBox, pBoxTo);
		if (fChange && null != this.tlChange) {
			this.tlChange.kill();
			this.tlChange = null;
		}
	}
	
	// 更新
	animeUpdate(newImage, cssProp, fChange) {
		let pBoxOut;
		let pBoxIn;
		if (YMSB_VIRT == this.vorhBox) {
			pBoxOut = {y:this.boxFrom, duration:ANI_DUR_BASE, ease:ANI_EASE_IN, delay:ANI_DELY_UPDATE,
				onStart:function(){
					if (fChange && null != this.tlChange) {
						this.tlChange.pause();
					}
				},
				onComplete:this.callBackImageUpdate(this.cssBox, newImage, cssProp)};
			pBoxIn  = {y:this.moveTo,  duration:ANI_DUR_BASE, ease:ANI_EASE_OUT,
				onComplete:function(){
					if (fChange && null != this.tlChange) {
						this.tlChange.resume();
					}
				}};
		}
		else {
			pBoxOut = {x:this.boxFrom, duration:ANI_DUR_BASE, ease:ANI_EASE_IN, delay:ANI_DELY_UPDATE,
				onStart:function(){
					if (fChange && null != this.tlChange) {
						this.tlChange.pause();
					}
				},
				onComplete:this.callBackImageUpdate(this.cssBox, newImage, cssProp)};
			pBoxIn  = {x:this.moveTo,  duration:ANI_DUR_BASE, ease:ANI_EASE_OUT,
				onComplete:function(){
					if (fChange && null != this.tlChange) {
						this.tlChange.resume();
					}
				}};
		}
		gsap.timeline()
			.to(this.cssBox, pBoxOut)
			.to(this.cssBox, pBoxIn);
	}

	// ■■ 画像更新コールバック
	callBackImageUpdate(cssName, strImg, cssProp) {
		return () => {
			if ("" != cssProp) {
				jQuery(cssName).css(cssProp);
			}
			else {
				const newImage = new Image();
				newImage.src = strImg;
				newImage.onload  = function() {
					jQuery(cssName).attr("src", strImg);
				}
				newImage.onerror = function() {
					jQuery(cssName).attr("src", "imgs/common/unknown.png");
				} 
			}
		};
	}
}
