// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	団体メンバーのアニメーション処理
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

class YmsbMember extends YmsbAnime {

	arrMoveSide = [YMSB_RIGHT, YMSB_LEFT];

	constructor(side, number, boxCSS, txtCSS, pDead, opacity) {
		super(opacity, boxCSS, txtCSS,
			YMSB_HORI, 0,
			YMSB_HORI, 0,
			ANI_DELY_ON_MEMBER, ANI_DELY_ON_MEMBER);
		this.boxFrom	= this.arrMoveSide[side] + ANI_MOVE_BOX_SIDE + "px";
		this.txtFrom	= this.arrMoveSide[side] + ANI_MOVE_BOX_SIDE + "px";
		this.moveTo		= ANI_MOVE_DEFAULT;
		this.side		= side;
		this.number		= number;
		this.pDead		= pDead;
	}

	// 表示
	animeOn(newMemberName, cssPropTxt, cssPropBox) {
		let pBoxFrom = {x:this.boxFrom, opacity:this.opacity};
		let pBoxTo   = {x:this.moveTo,  opacity:SB_MEMBER_BOX_OP,
				duration:ANI_DUR_BASE, ease:ANI_EASE_OUT, delay:this.delayBox};
		let	pTxtFrom = {x:this.txtFrom, opacity:1.0};
		let	pTxtTo   = {x:this.moveTo,
				duration:ANI_DUR_BASE, ease:ANI_EASE_OUT, delay:this.delayTxt,
				onStart:this.callBackMemberUpdate(newMemberName, cssPropTxt, cssPropBox)};
	
		gsap.set(this.cssBox, pBoxFrom);
		gsap.to (this.cssBox, pBoxTo);

		gsap.set(this.cssTxt, pTxtFrom);
		gsap.to (this.cssTxt, pTxtTo);
	}

	// 非表示
	animeOff() {
		let pMemberTo   = {x:this.boxFrom,
			duration:ANI_DUR_BASE, ease:ANI_EASE_IN, delay:ANI_DELY_OFF_MEMBER};

		gsap.to ([this.cssBox, this.cssTxt], pMemberTo);
	}
	
	// 更新
	animeUpdate(newMemberName, cssPropTxt, cssPropBox) {
		let pMemberOut = {x:this.txtFrom, duration:ANI_DUR_BASE, ease:ANI_EASE_IN, delay:ANI_DELY_UPDATE,
			onComplete:this.callBackMemberUpdate(newMemberName, cssPropTxt, cssPropBox)};
		let pMemberIn  = {x:this.moveTo,  duration:ANI_DUR_BASE, ease:ANI_EASE_OUT};

		gsap.timeline()
		.to([this.cssBox, this.cssTxt], pMemberOut)
		.to([this.cssBox, this.cssTxt], pMemberIn);
	}

	// コールバック
	callBackMemberUpdate(newMemberName, cssPropTxt, cssPropBox){
		return () => {
			jQuery(this.cssTxt).css(cssPropTxt);
			jQuery(this.cssBox).css(cssPropBox);
			jQuery(this.cssTxt).text(YmsbAnime.fitTextWidth(newMemberName, this.cssTxt));
		};
	}
}
