// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	イベントハンドラ
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ 初期設定 ■■
window.addEventListener("load", function() {
	setShortCut();
});

// ■■ 更新ボタン ■■
document.getElementById("upload").addEventListener("click", async (e) =>  {

	const jsonFromData = JSON.stringify(setJsonFromData(YMSB_JSON_TYPE), null, " ");
	const writable = await fileHandle.createWritable();
	await writable.write(jsonFromData);
	await writable.close();

	// 内部データを更新
	dataFromJson = JSON.parse(jsonFromData);
});

// ■■ SWAPボタン ■■
document.getElementById("swap").addEventListener("click", () =>  {
	swapData();
});

// ■■ やり直しボタン ■■
document.getElementById("undo").addEventListener("click", () =>  {
	setDataFromJson();
});

// ■■ ALLクリアボタン ■■
document.getElementById("clearAll").addEventListener("click", () =>  {
	clearData();
	setLifeData(jQuery("#maxMemberLives").val());
});

// ■■ CSVファイル読み込みボタン ■■
document.getElementById("loadCSV").addEventListener("click", async (e) =>  {
	copyToClipJsonFileName(YMSB_CSV_FILE_NAME);
	[CSVfileHandle] = await window.showOpenFilePicker();
	let csvData = await CSVfileHandle.getFile();
	csvData = await csvData.text();

	const CSV_DATA_LENGTH = 46;
	const data_string = csvData.split('\r\n');
	for (let i = 0; i < data_string.length; i++) {
		if (CSV_DATA_LENGTH < data_string[i].length) {
			csv_data_array[i] = data_string[i].split(',');
		}
	}

	// オートコンプリートのデータ設定
	setAutoComplete();

	// エキスパートモードのみCSVタブ内のデータを書き込み
	// Load CSVをSave CSVに変更する
	if (YMSB_TYPE_EXPERT == YMSB_JSON_TYPE) {
		setCSVView();
		jQuery("#loadCSV").css("display", "none");
		jQuery("#saveCSV").css("display", "block");
	}
});

// ■■ JSONファイル指定とデータ展開 ■■
document.getElementById("init").addEventListener("click", async (e) => {
	copyToClipJsonFileName(YMSB_JSON_FILE_NAME);
	[fileHandle] = await window.showOpenFilePicker();
	const file = await fileHandle.getFile();
	dataFromJson = await file.text();
	dataFromJson = JSON.parse(dataFromJson);
	setDataFromJson();
});

// ■■ ヘルプページ（よくある質問集）に飛ぶ ■■
document.getElementById("help").addEventListener("click", () =>  {
	window.open(YMSB_HELP_URL, '_blank', 'noreferrer');
});

// ■■ 10先スコアが更新されていれば優先する ■■
const scoreFT10_1 = document.querySelectorAll(`input[type="checkbox"][name="YMSB_FT10_1"]`);
const scoreFT10_2 = document.querySelectorAll(`input[type="checkbox"][name="YMSB_FT10_2"]`);
const scoreCheck  = [scoreFT10_1, scoreFT10_2];
const arrSingleScore = ["#pScore1", "#pScore2"];
const setScoreFT10 = () => {
	if ("1" == jQuery("#bottomView").val()) {
		let scores = new Array(2);
		for (let i = 0; i < 2; i++) {
			scores[i] = 0;
			for (let score of scoreCheck[i]) {
				if(score.checked) {scores[i] ++;}
			}
			jQuery(arrSingleScore[i]).val(scores[i]);
		}
	}
}
for (let i = 0; i < 2; i++) {
	for (let score of scoreCheck[i]) {
		score.addEventListener("change", () => {
			setScoreFT10();
		});
	}
}
document.getElementById("bottomView").addEventListener("change", () =>  {
	if ("1" == jQuery("#bottomView").val()) {
		setScoreFT10();
	}
});

document.addEventListener("DOMContentLoaded", function() {
	if (YMSB_TYPE_EXPERT == YMSB_JSON_TYPE) {
		setLanguage(YMSB_DEF_LANG, false);
	}
});

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	イベントハンドラで使う関数
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ JSONファイルのファイルパスをクリップボードにコピー ■■
const copyToClipJsonFileName = (fileName) => {
	let localPathName = decodeURI(location.pathname);
	localPathName = localPathName.slice(0, YMSB_FILEPATH_MATH);
	localPathName = localPathName.replace(/\//g, "\\");
	localPathName += fileName;

	// Windows以外（mac）の場合は[C:]を削除し[\]を[/]に置換
	let osCheck = window.navigator.userAgent.toLowerCase();
	if ( osCheck.indexOf("windows") == -1 ) {
		localPathName = localPathName.replace(/\\/g, "/");
	}
	else {
		localPathName = localPathName.slice(1);
	}

	navigator.clipboard.writeText(localPathName);
	return localPathName;
}
